newTalentType{ type="cunning/distraction", name"Distraction", description="Distract your enemies with various tools of the trade." }
cun_req1 = {
	stat = { cun=function(level) return 12 + (level-1) * 2 end },
	level = function(level) return 0 + (level-1)  end,
}
cun_req2 = {
	stat = { cun=function(level) return 20 + (level-1) * 2 end },
	level = function(level) return 4 + (level-1)  end,
}
cun_req3 = {
	stat = { cun=function(level) return 28 + (level-1) * 2 end },
	level = function(level) return 8 + (level-1)  end,
}
cun_req4 = {
	stat = { cun=function(level) return 36 + (level-1) * 2 end },
	level = function(level) return 12 + (level-1)  end,
}
cun_req5 = {
	stat = { cun=function(level) return 44 + (level-1) * 2 end },
	level = function(level) return 16 + (level-1)  end,
}

local function canUseSkills(self)
    local nb = 0
    local weapon
    
    if self:getInven("MAINHAND") then
        weapon = self:getInven("MAINHAND")[1]
        if weapon and weapon.subtype == "dagger" then
            nb = nb + 1
        end
    end
    
    if self:getInven("OFFHAND") then
        weapon = self:getInven("OFFHAND")[1]
        if not weapon then
            nb = nb + 1
--         if weapon.subtype == "blowpipe" then
--            nb = nb + 1
        end
    end
    return nb >= 2 and true or false
end

newTalent{
    name ="Toxic Blowdart", short_name ="BLOWDART_TOXIC",
    type = {"cunning/destraction", 1},
    require = cun_req1,
    mode = "activated",
    points = 5,
    stamina = 5,
    cooldown = 12,
    no_break_stealth = true,
    range = 5,
    requires_target = true,
    getDuration = function(self, t) return math.floor(self:combatTalentScale(t, 1, 5)) end,
    
    getDamage = function(self, t) return self:combatScale(self:getTalentLevel(t) * self:getCun(25, true), 0, 0, 30, 50) end,
    action =  function(self, t)
        local tg = {type="hit", range=range, talent=t}
		local x, y, target = self:getTarget(tg)
		if not x or not y or not target then return nil end
        if core.fov.distance(self.x, self.y, x, y) > 1 then return nil end
        local hitted = self:attackTarget(target, nil, 1, true)
        if hitted then
            if target:canBe("poison") then
                target:setEffect(self.POISONED, t.getDuration(self, t), {power=t.getDamage(self, t)}
            end
            else
                self:logCombat(target, "#Target# resists the poison!")
            end
        end
    end,
    info = function(self, t)
        return ([[Shoot a poisoned blowdart at your foe. This doesn’t break stealth.
        Causes the target to take %d Poison damage each turn for %d turns(Total: %d). The damage scales with your Cunning.]]):
        format(t.getDamage(self, t), t.getDuration(self, t), t.getDamage(self, t) * t.getDuration(self,t))
    end,
}
local basetrap = function(self, t, x, y, dur, add)
	local Trap = require "mod.class.Trap"
	local trap = {
		id_by_type=true, unided_name = "trap",
		display = '^',
		faction = self.faction,
		summoner = self, summoner_gain_exp = true,
		temporary = dur,
		x = x, y = y,
		detect_power = math.floor(trapPower(self,t)),
		disarm_power = math.floor(trapPower(self,t)*1.25),
		canAct = false,
		energy = {value=0},
		inc_damage = table.clone(self.inc_damage or {}, true),
		resists_pen = table.clone(self.resists_pen or {}, true),
		act = function(self)
			if self.realact then self:realact() end
			self:useEnergy()
			self.temporary = self.temporary - 1
			if self.temporary <= 0 then
				if game.level.map(self.x, self.y, engine.Map.TRAP) == self then
					game.level.map:remove(self.x, self.y, engine.Map.TRAP)
					if self.summoner and self.stamina then -- Refund
						self.summoner:incStamina(self.stamina * 0.8)
					end
				end
				game.level:removeEntity(self)
			end
		end,
	}
	table.merge(trap, add)
	return Trap.new(trap)
end
newTalent{
    name ="Caltrops", short_name ="CALTROPS",
    type = {"cunning/destraction", 2},
    require = cun_req2,
    mode = "activated",
    points = 5,
    stamina = 10,
    cooldown = 10,
    no_break_stealth = true,
    range = 1
    getSlow =
    getSlowDur =
    getBleed =
    getBleeDur =
    action = function(self, t)
        local x = self.x
        local y = self.y
        
