newTalentType{ type="technique/deviousness", name"Deviousness", description="There is no shame in fighting deviously" }
dex_req1 = {
	stat = { dex=function(level) return 12 + (level-1) * 2 end },
	level = function(level) return 0 + (level-1)  end,
}
dex_req2 = {
	stat = { dex=function(level) return 20 + (level-1) * 2 end },
	level = function(level) return 4 + (level-1)  end,
}
dex_req3 = {
	stat = { dex=function(level) return 28 + (level-1) * 2 end },
	level = function(level) return 8 + (level-1)  end,
}
dex_req4 = {
	stat = { dex=function(level) return 36 + (level-1) * 2 end },
	level = function(level) return 12 + (level-1)  end,
}
dex_req5 = {
	stat = { dex=function(level) return 44 + (level-1) * 2 end },
	level = function(level) return 16 + (level-1)  end,
}
local function canUseSkills(self)
    local nb = 0
    local weapon
    
    if self:getInven("MAINHAND") then
        weapon = self:getInven("MAINHAND")[1]
        if weapon and weapon.subtype == "dagger" then
            nb = nb + 1
        end
    end
    
    if self:getInven("OFFHAND") then
        weapon = self:getInven("OFFHAND")[1]
        if not weapon then
            nb = nb + 1
--         if weapon.subtype == "blowpipe" then
--            nb = nb + 1
        end
    end
    return nb >= 2 and true or false
end

newTalent{
    name ="Assassin's Advantage", short_name ="ASSASSIN_ADV",
    type = {"technique/deviousness", 1},
    require = dex_req1,
    mode = "sustained",
    points = 5,
    sustain_stamina = 10,
    cooldown = 12,
    tactical = {DEFEND = 2 },
    getCriticalChance = function(self, t)
        return math.ceil(self:combatTalentLimit(t, 0.20, 0.01, 0.15, 0.75)) end,
    getEvasion = function(self, t)
        return self:combatTalentScale(t, 0.10, 0.20, 0.75)            
    on_pre_use = function(self, t, silent) 
        if not canUseSkills(self) then
                if not silent then
                    game.logPlayer(self, "You require a dagger and a free hand to use this talent.") end return false end return true end,
    activate = function(self, t)
        if not canUseSkills(self) then
            game.logPlayer(self, "You require a dagger and a free hand to use this talent.")
            return nil
        end
        return {
            evade =  self:addTemporaryValue("evasion", t.getEvasion(self, t),
            crit = self:addTemporaryValue("combat_physcrit", t.getCriticalChance(self, t),
        }
    end,
    deactivate = function(self, t, p)
        self:removeTemporaryValue("evasion", p.evade)
        self:removeTemporaryValue("combat_physcrit", p.crit)
        return true
    end,
    info = function(self, t)
        return ([[You eschew the wild swings of your rogue counterparts, instead focusing on a sole Dagger. 
        Gain %d%% critical chance, and a %d evasion while using a single Dagger.]]):
        format(t.getCriticalChance(self, t)*100, t.getEvasion(self, t), )
    end,
}

newTalent{
    name = "Dance of Death",
    short_name = "ASSASSIN_DANCE",
    type = {"technique/deviousness", 2},
    require = dex_req2,
    mode = "sustained"
    sustain_stamina = 30,
    cooldown = 30,
    tactical = {DEFEND = 2}
    getChance = function(self, t)
        return self:combatScale(self:getTalentLevel(t) * self:getDex(25, true), 0, 0, .50, .50) end,
    getExtDmg = function(self, t)
        return self:combatScale(self:getTalentLevel(t) * self:getCun(25, true), 0, 0, .30, .50) end,
    getDmgTurns = function(self, t)
        return self:combatTalentScale(t, 1, 5, 0.75)
    HasCloak = function(self, t)
        if self:getInven("CLOAK") then
            cloak = self:getInven("CLOAK")[1]
        if not cloak then
            return false
        end
        return true
    end
    
    activate = function(self, t)
        if not HasCloak then
            game.logPlayer(self, "You require a cloak use this talent.")
            return nil
        end
        callbackOnMeleeMiss
            local tg = {type="hit", range=1}
            local x, y, target = self:getTarget(tg)
            if not x or not y or not target then return nil end
            if core.fov.distance(self.x, self.y, x, y) > 1 then return nil end
            self:move(x+1, y+1, false)
            target:setEffect(self.EFF_DAN_DEATH, t.getDmgTurns(self, t), {power=t.getExtDmg(self, t)})
            return true
        end
    end,
    info = function(self, t)
        local chance = t.getChance(self, t) * 100
        local extra = t.getExtDmg(self, t) * 100
        local turns = t.getDmgTurns(self, t)
        return ([[You dance around your foes as if life and death were a mere game. 
        If you dodge an attack, you have a %d%% chance to be able to move behind the target. 
        If you do so, you gain %d%% more damage on your next attack against that foe within %d turns. Requires a cloak. 
        The chance to move scales with Dexterity, and the extra damage scales with Cunning. ]]):
        format(chance, extra, turns)
    end,
}

newTalent{
    name = "Throat Cutter",
    short_name = "THROATCUT",
    type = {"technique/deviousness", 3},
    require = dex_req3,
    mode = "activated",
    requires_target = true,
    stamina = 20,
    cooldown = 12,
    range = 1,
    getDamage = function(self, t) return self:combatTalentWeaponDamage(t, 1, 1.5, Dex) end,
    getAirDamage = function (self, t) return combatTalentIntervalDamage(t, Dex, 20, 60, 0.75)
	getDuration = function(self, t) return math.floor(self:combatTalentScale(t, 3, 7)) end,

    action =  function(self, t)
        local tg = {type="hit", range=self:getTalentRange(t), talent=t}
		local x, y, target = self:getTarget(tg)
		if not x or not y or not target then return nil end
        if core.fov.distance(self.x, self.y, x, y) > 1 then return nil end
        local hit = self:attackTargetWith(target, weapon.combat, nil, t.getDamage(self, t))
        if hit then
            if not target:attr("no_breath") then
                target:setEffect(self.EFF_THROATCUT, t.getDuration(self, t), {power=t.getAirDamage(self, t)}
            else
                game.logSeen(target, "%s doesn't seem to be affected by the cutting of their throat!", target.name:capitalize())
            end
        end
            
        return true
    end,
    info = function(self, t)
		return ([[Aim for the enemy’s throat. Does %d%% damage, and silences the target for %d turns. 
        In addition, the target loses %d Air, and cannot regain air for %d turns. The damage scales with Dexterity]]):
		format(100 * t.getDamage(self, t), t.getDuration(self, t), t.getAirDamage(self, t), t.getDuration(self, t))
	end,
}

newTalent{
    name = "Marked For Death",
    short_name = "DEATHMARK",
    type = {"technique/deviousness", 4},
    require = dex_req4,
    mode = "activated",
    requires_target = true,
    stamina = 20,
    cooldown = 12,
    range = 1,
    no_break_stealth = true,
	getDuration = function(self, t) return math.floor(self:combatTalentScale(t, 3, 10)) end,
    getDuration2 = function(self, t) return math.floor(self:combatTalentScale(t, 3, 12)) end,
    getExtDmg = function(self, t) return self:combatScale(self:getTalentLevel(t) * self:getCun(25, true), 0, 0, .30, .50) end,
    getEffect = function(self, t) return self:combatScale(self:getTalentLevel(t) * self:getDex(25, true), 0, 0, .50, .50) end,
    getRadius = function(self, t) return math.floor(self:combatTalentScale(t, 1, 4)) end,
    action =  function(self, t)
        local tg = {type="hit", range=self:getTalentRange(t), talent=t}
		local x, y, target = self:getTarget(tg)
		if not x or not y or not target then return nil end
        if core.fov.distance(self.x, self.y, x, y) > 1 then return nil end
        target:setEffect(self.MARKEDFORDEATH, t.getDuration(self, t), {power=t.getExtDmg(self, t), radius=t.getRadius(self, t)}
    end,
    info = function(self, t)
        return ([[Mark an enemy, heralding their immediate demise. 
        This does not break Stealth, and causes the target to take %d%% more damage for %d turns.
        If the target dies during this duration, enemies in a radius of %d are horrified, losing %d accuracy and defense for %d turns.]]):
        format(100 * t.getExtDmg(self, t), t.getDuration(self, t), t.getRadius(self, t), t.getEffect(self, t), t.getDuration2(self, t))
    end,
}
